/////////////////////////////////////////////LIBRARIES/////////////////////////////////////////////////
#include "BasicStepperDriver.h"
#include "SyncDriver.h"
#include "MultiDriver.h"
#include "Stepper.h"
#include <SoftwareSerial.h>

/////////////////////////////////////////////INTERGERS///////////////////////////////////////////////////
SoftwareSerial mySerial(4, 7); // RX, TX
int C = 0;     // Turn count related
int state = 0; 
int EN = 12;
String message;
int QTY, numMessages, endBytes;
byte inByte;
int flag = 0;

////////////////////////////////////////////DEFINITIONS/////////////////////////////////////////////////
#define DIR_X 5 //A0
#define STEP_X 2 //A1
#define DIR_Y 6 //A2
#define STEP_Y 3 //A3
#define MICROSTEPS 1 //(1,2,4,6,8,16,32)
#define MOTOR_STEPS 200 //must stay 200

int count = 1;
BasicStepperDriver stepperX(MOTOR_STEPS, DIR_X, STEP_X);
BasicStepperDriver stepperY(MOTOR_STEPS, DIR_Y, STEP_Y);
SyncDriver controller(stepperX, stepperY);
//MultiDriver controller(stepperX, stepperY); //this is new

////////////////////////////////////////////////VOID SETUP//////////////////////////////////////////////
void setup()
{ 
  pinMode(EN,OUTPUT);
  digitalWrite(EN,HIGH);
  numMessages, endBytes = 0;
  Serial.begin(9600);
  mySerial.begin(9600);
  stepperX.begin(150, 1); // RPM, Microsteps.
  stepperY.begin(150, 1); // RPM, Microsteps.
  //delay(500); //??????????????
}

//  if (A > 0 && B > 0 && C > 0) { //cut code

/////////////////////////////////////////////VOID LOOP//////////////////////////////////////////////////
void loop()
{
  data();
  if (C > 0) {
    digitalWrite(EN,LOW);
if (count <= C){

// int i = 0 means start at 0, i <=0 is the condition to trigger the loop, i++ means turn count increases, if count is greater than C, repeat.
for (int i = 0; i <= 0; i++){
  if (count > C){
break;
  }

controller.rotate(90,150);
controller.rotate(90,-150); 
controller.rotate(90,150);
controller.rotate(86,-150); 

//controller.rotate(180,360); 170/180, 200/200




// Refresh turn count value, increasing until reach input value rx/tx communication to nextion
mySerial.print("n2.val=");
mySerial.print(count);
mySerial.write(0xff);
mySerial.write(0xff);
mySerial.write(0xff);
count++;  
}
}   
}
}


void data() {


if (state == 0) {
      if (numMessages == 1) { //Did we receive the anticipated number of messages? In this case we only want to receive 1 message.
        C = QTY;
        Serial.println(C);//See what the important message is that the Arduino receives from the Nextion
        numMessages = 0; //Now that the entire set of data is received, reset the number of messages received
        state = 0;
      }
    }
    






   if (mySerial.available()) { //Is data coming through the serial from the Nextion?
      inByte = mySerial.read();

      // Serial.println(inByte); //See the data as it comes in

      if (inByte > 47 && inByte < 58) { //Is it data that we want to use?
        message.concat(char(inByte)); //Cast the decimal number to a character and add it to the message
      }
      else if (inByte == 255) { //Is it an end byte?
        endBytes = endBytes + 1; //If so, count it as an end byte.
      }

      if (inByte == 255 && endBytes == 3) { //Is it the 3rd (aka last) end byte?
        QTY = message.toInt(); //Because we have now received the whole message, we can save it in a variable.
        message = ""; //We received the whole message, so now we can clear the variable to avoid getting mixed messages.
        endBytes = 0; //We received the whole message, we need to clear the variable so that we can identify the next message's end
        numMessages  = numMessages + 1; //We received the whole message, therefore we increment the number of messages received.

        //Now lets test if it worked by playing around with the variable.

      }
    }
  }
